<?php

include_once('../common/init.loader.php');

if ($FORM['dostripe'] == 'cancel' && md5($FORM['subsid'] . INSTALL_KEYS) == $FORM['hashcnl']) {
    $subscriptionID = $FORM['subsid'];
    $rescancel = do_stripesubscancel($subscriptionID);
    $cancel_json = json_decode($rescancel);

    $condition = " AND mptoken LIKE '%|stripesubsid:{$subscriptionID}|%'";
    $row = $db->getAllRecords(DB_TBLPREFIX . '_mbrplans', '*', $condition . "");
    $mbrstr = getmbrinfo('', '', $row[0]['mpid']);
    if ($mbrstr['id'] > 0) {
        $mptoken = $mbrstr['mptoken'];
        $mptoken = put_optionvals($mptoken, 'stripestatus', 'canceled');
        $data = array(
            'mptoken' => $mptoken,
        );
        $update = $db->update(DB_TBLPREFIX . '_mbrplans', $data, array('mpid' => $mbrstr['mpid']));
    }

    redirpageto($cfgrow['site_url'] . '/' . MBRFOLDER_NAME . '/index.php?hal=dashboard');
}

$pgdatatokenarr = get_optionvals($payrow['pgdatatoken']);
$stripecfg = get_optarr($pgdatatokenarr['stripecfg']);

$formqry = '';
foreach ($FORM as $key => $value) {
    $value = urlencode($value);
    $formqry .= "&{$key}={$value}";
}
printlog('stripe.ipv', "postback: {$formqry}");

if ($FORM['event'] == 'webhook') {
    require_once('../assets/fellow/stripe-php/init.php');
    $stripe = new \Stripe\StripeClient($stripecfg['stripepass']);

    // retrieve the request's body and parse it as JSON
    $body = @file_get_contents('php://input');
    $event_json = json_decode($body);

    $event_id = $event_json->id;

    if ($event_id) {
        $event = $stripe->events->retrieve($event_id, []);
        $event_type = $event->type;
        printlog('stripe.ipv', "event_type: {$event_type}");
        printlog('stripe.ipv', "event: {$event}");

        $createdDT = $event_json->data->object->created;

        // This will send receipts on succesful invoices
        if ($event_type == 'invoice.paid') {
            $invoiceID = $event_json->id;
            $subscriptionID = $event_json->data->object->subscription;
            $transactionID = $event_json->data->object->charge;
            $transactionID = ($transactionID == null) ? $invoiceID : $transactionID;
            $customerID = $event_json->data->object->customer;
            $paidAmount = floatval($event_json->data->object->subtotal_excluding_tax / 100);

            $condition = " AND mptoken LIKE '%|stripesubsid:{$subscriptionID}|%'";
            $row = $db->getAllRecords(DB_TBLPREFIX . '_mbrplans', '*', $condition . "");
            $mbrstr = getmbrinfo('', '', $row[0]['mpid']);
            $stripecreadt = get_optionvals($mbrstr['mptoken'], 'stripecreadt');
            if ($mbrstr['id'] > 0 && $stripecreadt < $createdDT) {
                $mptoken = $mbrstr['mptoken'];
                $mptoken = put_optionvals($mptoken, 'stripecreadt', $createdDT);
                $data = array(
                    'mptoken' => $mptoken,
                );
                $update = $db->update(DB_TBLPREFIX . '_mbrplans', $data, array('mpid' => $mbrstr['mpid']));

                $txmpid = "STRP-{$mbrstr['mpid']}";

                include_once('../common/sandbox.php');
                $FORM['sb_type'] = 'payreg';
                $FORM['sb_subs'] = 'renew';
                $FORM['sb_ikey'] = INSTALL_KEYS;
                doipnbox($txmpid, $paidAmount, 'stripeacc', $transactionID, '', 'continue', 0, '');
            }
        } else if ($event_type == 'subscription_schedule.canceled' || $event_type == 'subscription_schedule.updated' || $event_type == 'customer.subscription.updated' || $event_type == 'customer.subscription.deleted') {
            $subscriptionID = $event_json->data->object->id;
            $statusStr = $event_json->data->object->status;

            if ($statusStr != '') {
                $condition = " AND mptoken LIKE '%|stripesubsid:{$subscriptionID}|%'";
                $row = $db->getAllRecords(DB_TBLPREFIX . '_mbrplans', '*', $condition . "");
                $mbrstr = getmbrinfo('', '', $row[0]['mpid']);
                $stripecreadt = get_optionvals($mbrstr['mptoken'], 'stripecreadt');

                if ($mbrstr['id'] > 0 && $stripecreadt < $createdDT) {
                    $mptoken = $mbrstr['mptoken'];
                    $mptoken = put_optionvals($mptoken, 'stripecreadt', $createdDT);
                    $mptoken = put_optionvals($mptoken, 'stripestatus', $statusStr);
                    $data = array(
                        'mptoken' => $mptoken,
                    );
                    $update = $db->update(DB_TBLPREFIX . '_mbrplans', $data, array('mpid' => $mbrstr['mpid']));
                }
            }
        }
    } else {
        // error - event id empty
    }
}

$session_id = $FORM['session_id'];
if ($session_id != '') {
    try {
        require_once('../assets/fellow/stripe-php/init.php');
        \Stripe\Stripe::setApiKey($stripecfg['stripepass']);

        // Fetch the Checkout Session to display the JSON result on the success page
        try {
            $checkout_session = \Stripe\Checkout\Session::retrieve($session_id);
        } catch (Exception $e) {
            $api_error = $e->getMessage();
        }

        if (empty($api_error) && $checkout_session) {
            // Check whether the charge is successful
            if ($checkout_session->payment_status == 'paid') {

                // Transaction details
                $paymentID = $checkout_session->id; // id transaction
                $customerID = $checkout_session->customer; // id customer
                $subscriptionID = $checkout_session->subscription; // id subscription
                $invoiceID = $checkout_session->invoice;
                $createdDT = $checkout_session->created;

                $transactionID = $checkout_session->payment_intent;
                $transactionID = ($transactionID == null) ? $invoiceID : $transactionID;

                $paidAmount = $checkout_session->amount_subtotal;
                $paidAmount = $paidAmount / 100;
                $client_reference_id = $checkout_session->client_reference_id;

                $isestoreorder = (strpos($client_reference_id, 'BELINV') !== false) ? 1 : '';

                $sb_txmpidarr = explode('-', $client_reference_id);
                $txid = $sb_txmpidarr[0];
                $mpid = $sb_txmpidarr[1];

                if ($subscriptionID != '') {
                    // create webhook
                    $stripe = new \Stripe\StripeClient($stripecfg['stripepass']);
                    $webhook_res = $stripe->webhookEndpoints->create([
                        'enabled_events' => ['invoice.paid', 'invoice.payment_failed', 'invoice.payment_action_required', 'subscription_schedule.canceled', 'subscription_schedule.updated', 'customer.subscription.deleted', 'customer.subscription.updated', 'checkout.session.completed', 'charge.succeeded', 'charge.failed'],
                        'url' => $cfgrow['site_url'] . '/common/stripe.ipv.php?event=webhook',
                    ]);
                    $webhookID = $webhook_res->id;
                    $webhooksecret = $webhook_res->secret;

                    // add subscription token
                    if ($isestoreorder == 1) {
                        
                    } else {
                        $mbrstr = getmbrinfo('', '', $mpid);
                        $mptoken = $mbrstr['mptoken'];
                        $mptoken = put_optionvals($mptoken, 'stripesubsid', $subscriptionID);
                        $mptoken = put_optionvals($mptoken, 'stripecustid', $customerID);
                        $mptoken = put_optionvals($mptoken, 'stripecreadt', $createdDT);
                        $mptoken = put_optionvals($mptoken, 'stripewhookid', $webhookID);
                        $mptoken = put_optionvals($mptoken, 'stripewhooksecret', $webhooksecret);
                        $mptoken = put_optionvals($mptoken, 'stripestatus', '');
                        $data = array(
                            'mptoken' => $mptoken,
                        );
                        $update = $db->update(DB_TBLPREFIX . '_mbrplans', $data, array('mpid' => $mbrstr['mpid']));
                    }

                    // add token
                    $addtoken = "|stripepaymid:{$paymentID}|";
                } else {
                    $addtoken = '';
                }

                //Perform necessary action
                if ($isestoreorder == 1) {
                    include_once('../common/sendbox.php');
                    $FORM['sb_type'] = 'payreg';
                    doipnbox($client_reference_id, $paidAmount, 'stripeacc', $transactionID, '', 'continue', 0, $addtoken);
                } else {
                    include_once('../common/sandbox.php');
                    $FORM['sb_type'] = 'payreg';
                    doipnbox($client_reference_id, $paidAmount, 'stripeacc', $transactionID, '', 'continue', 0, $addtoken);
                }
            } else {
                $statusMsg = "Transaction has been failed!";
            }
        } else {
            $statusMsg = "Transaction has been failed! $api_error";
        }
        if ($statusMsg != '') {
            redirpageto($cfgrow['site_url'] . '/' . MBRFOLDER_NAME . '/index.php?hal=planpay&msg=' . $statusMsg);
            exit();
        } else {
            redirpageto($cfgrow['site_url'] . '/' . MBRFOLDER_NAME . '/ipnhub.php?hal=dashboard');
            exit();
        }
    } catch (Exception $e) {
        // Something else happened, completely unrelated to Stripe
    }
    redirpageto($cfgrow['site_url'] . '/' . MBRFOLDER_NAME . '/index.php?hal=planpay&stripe_form=session_id');
} elseif ($FORM['stripe_txmpid'] != '') {
    try {
        require_once('../assets/fellow/stripe-php/init.php');
        \Stripe\Stripe::setApiKey($stripecfg['stripepass']);

        $charge = \Stripe\Charge::create(array(
                    "amount" => $_POST['amount'],
                    "currency" => $_POST['currency'],
                    "card" => $_POST['stripeToken'],
                    "description" => $_POST['description']
        ));
        $paidbatch = $charge->balance_transaction;
        $amountreal = $_POST['amount'] / 100;

        $stripe_txmpid = $_POST['stripe_txmpid'];

        //Perform necessary action
        if (strpos($stripe_txmpid, 'BELINV') !== false) {
            include_once('../common/sendbox.php');
            $FORM['sb_type'] = 'payreg';
            doipnbox($stripe_txmpid, $amountreal, 'stripeacc', $paidbatch, '', 'continue', 0, '');
        } else {
            include_once('../common/sandbox.php');
            $FORM['sb_type'] = 'payreg';
            doipnbox($stripe_txmpid, $amountreal, 'stripeacc', $paidbatch, '', 'continue', 0, '');
        }

        redirpageto($cfgrow['site_url'] . '/' . MBRFOLDER_NAME . '/ipnhub.php?hal=dashboard');
        exit();
    } catch (Exception $e) {
        // Something else happened, completely unrelated to Stripe
    }
    redirpageto($cfgrow['site_url'] . '/' . MBRFOLDER_NAME . '/index.php?hal=planpay&stripe_form=stripe_txmpid');
}
